using System;
using System.Text;
using System.Linq;
using System.Collections.Generic;

/// @author Antti-Jussi Lakanen
/// @version 2025
/// 
/// <summary>
/// Luento 9, while ja do-while
/// </summary>
public class Silmukat
{
    /// <summary>
    /// Silmukat 
    /// </summary>
    public static void Main()
    {
        // Esimerkki 1
        // while-silmukkarakenne soveltuu hyvin tilanteisiin, 
        // joissa toistojen määrä ei ole ennalta tiukasti kiinnitetty.
        double kerrottava = 1.0;
        int kierroksia = 0;
        while (kerrottava <= 1000)
        {
            kerrottava = kerrottava * 1.1;
            kierroksia++;
        }

        Console.WriteLine($"Luku on: {kerrottava}");
        Console.WriteLine($"Tehtiin {kierroksia} kierrosta.");

        // Esimerkki 2
        // Hallittu ikuinen silmukka
        string syote = "";
        while (true)
        {
            Console.Write("Anna syöte > ");
            syote = Console.ReadLine();
            if (syote == "Jypeli") break;
        }

        // Esimerkki 3
        // Hallittu ikuinen silmukka 2
        // Tässä esimerkissä pyydetään käyttäjältä syöte ja
        // lasketaan kuinka monta lukua käyttäjä syöttää ennen nollaa.  
        // Kun käyttäjä syöttää luvun 0, näytetään lukujen määrä.
        int lukuja = 0;
        int luku = 0;
        while (true)
        {
            Console.Write("Anna luku > ");
            luku = int.Parse(Console.ReadLine());
            if (luku == 0) break;
            lukuja++;
        }

        Console.WriteLine($"Syötit {lukuja} nollasta poikkeavaa lukua.");

        // Esimerkki 4
        // Lopuksi vielä do-while-rakenne.
        // do-osa tehdään aina vähintän yhden kerran.
        // Minkälaisiin tilanteisiin do-while-silmukka soveltuu?
        // Tilanteisiin, joissa VARMASTI haluamme tehdä 
        // asian vähintään kerran, esimerkiksi salasanan kysyminen,
        // sopivan paikan etsiminen pelikentältä vihulle,
        // kun kentällä on esteitä 
        int laskuriDoWhile = 0;
        do
        {
            Console.WriteLine(laskuriDoWhile);
            laskuriDoWhile++;
        } while (laskuriDoWhile < 0);
    }
}