using System;
using System.Text;
using System.Linq;
using System.Collections.Generic;

/// @author Antti-Jussi Lakanen
/// @version 2025
/// <summary>
/// Luento 9, debuggaus
/// </summary>
public class Debuggaus
{
    /// <summary>
    /// Harjoitellaan debuggausta
    /// </summary>
    public static void Main()
    {
        double pertinRahat = 100.0;
        double korkokerroin = 1.07;
        // Silmukan tarkoitus on tässä "simuloida" vuosien kulumista
        // 10 vuotta tässä tapauksessa
        for (int i = 0; i < 10; i++)
        {
            pertinRahat = Sijoitus(pertinRahat, korkokerroin);
            pertinRahat = Kulutus(pertinRahat, 8.90);
            Console.WriteLine($"Pertillä on nyt {pertinRahat} rahaa!");
        }
    }

    /// <summary>
    /// Pertti kuluttaa rahaa
    /// </summary>
    /// <param name="paaoma">Alkuperäinen pääoma</param>
    /// <param name="kulutettavaSumma">Kulutettava summa</param>
    /// <returns>Pääoma kulutuksen jälkeen</returns>
    public static double Kulutus(double paaoma, double kulutettavaSumma)
    {
        return paaoma - kulutettavaSumma;
    }

    /// <summary>
    /// Pertti sijoittaa rahaa
    /// </summary>
    /// <param name="paaoma">Alkuperäinen pääoma</param>
    /// <param name="korkokerroin">Korkokerroin</param>
    /// <returns>Pääoma sijoituksen jälkeen</returns>
    public static double Sijoitus(double paaoma, double korkokerroin)
    {
        return paaoma * korkokerroin;
    }
}