using System;
using System.Text;
using System.Linq;
using System.Collections.Generic;

/// @author Antti-Jussi
/// @version 2025
/// <summary>
/// Luento 9, taulukot
/// </summary>
public class Taulukot
{
    /// <summary>
    /// Taulukot
    /// </summary>
    public static void Main()
    {
        // Alla useita "samaan asiaan" 
        // liittyviä muuttujia
        int luento1 = 200;
        int luento2 = 180;
        int luento3 = 100;
        int luento4 = 50;
        int luento5 = 57;


        // Lasketaan luennolla kävijöiden keskiarvo
        int summa = luento1 + luento2 + luento3 + luento4 + luento5;
        Console.WriteLine($"Luennoille osallistui yhteensä {summa} henkilöä.");
        double keskiarvo = summa / 5.0;
        Console.WriteLine($"Luenoilla osallistui keskimäärin {keskiarvo} opiskelijaa.");

        // Luvut voidaan sijoittaa taulukkoon
        int[] luentojenOsallistujat = new int[] { 200, 180, 100, 50, 57 };
        int summa2 = luentojenOsallistujat[0]
                     + luentojenOsallistujat[1]
                     + luentojenOsallistujat[2]
                     + luentojenOsallistujat[3]
                     + luentojenOsallistujat[4];
        double keskiarvo2 = summa2 * 1.0 / luentojenOsallistujat.Length;
        Console.WriteLine($"Luenoilla osallistui keskimäärin {keskiarvo2} opiskelijaa.");

        // Yritetään laittaa taulukkoon "kuudes" luento ja sille osallistujamäärä 20
        // luentojenOsallistujat[5] = 20; 

        // Taulukon läpikäymiseen voidaan hyödyntää silmukkaa.
        // Käymme läpi taulukkoa alkaen indeksistä 0, ja päättyen indeksiin "Length"
        int summa3 = 0;
        for (int i = 0; i < luentojenOsallistujat.Length; i++)
        {
            // Tulostetaan aluksi kullekin luennolle osallistujien lkm
            // Console.WriteLine($"Paikassa {i} on luku: {luentojenOsallistujat[i]}");
            summa3 += luentojenOsallistujat[i];
        }

        double keskiarvo3 = summa3 * 1.0 / luentojenOsallistujat.Length;
        Console.WriteLine(summa3);
        Console.WriteLine($"Luennoilla oli keskimäärin {keskiarvo3} opiskelijoita.");

        string[] henkilot = { "Antti-Jussi", "Jonne", "Vesa", "Tuomo" };
        for (int i = 0; i < henkilot.Length; i++)
        {
            Console.WriteLine(henkilot[i]);
        }
    }
}